Package org.apache.commons.math3.optim.linear

# Class LinearOptimizer

java.lang.Object
org.apache.commons.math3.optim.BaseOptimizer<PointValuePair>
org.apache.commons.math3.optim.BaseMultivariateOptimizer<PointValuePair>
org.apache.commons.math3.optim.nonlinear.scalar.MultivariateOptimizer
org.apache.commons.math3.optim.linear.LinearOptimizer

Direct Known Subclasses:
  `SimplexSolver`

public abstract class LinearOptimizer extends MultivariateOptimizer
Base class for implementing linear optimizers.

Since:
  3.1

## Field Summary

### Fields inherited from class org.apache.commons.math3.optim.BaseOptimizer

`evaluations, iterations`

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`LinearOptimizer()`
Simple constructor with default settings.

## Method Summary

Modifier and Type
Method
Description
`protected Collection<LinearConstraint>`
`getConstraints()`
`protected LinearObjectiveFunction`
`getFunction()`
`protected boolean`
`isRestrictedToNonNegative()`
`PointValuePair`
`optimize(OptimizationData... optData)`
Stores data and performs the optimization.
`protected void`
`parseOptimizationData(OptimizationData... optData)`
Scans the list of (required and optional) optimization data that characterize the problem.

### Methods inherited from class org.apache.commons.math3.optim.nonlinear.scalar.MultivariateOptimizer

`computeObjectiveValue, getGoalType`

### Methods inherited from class org.apache.commons.math3.optim.BaseMultivariateOptimizer

`getLowerBound, getStartPoint, getUpperBound`

### Methods inherited from class org.apache.commons.math3.optim.BaseOptimizer

`doOptimize, getConvergenceChecker, getEvaluations, getIterations, getMaxEvaluations, getMaxIterations, incrementEvaluationCount, incrementIterationCount, optimize`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### LinearOptimizer

protected LinearOptimizer()
Simple constructor with default settings.

## Method Details

### isRestrictedToNonNegative

protected boolean isRestrictedToNonNegative()

Returns:
  `true` if the variables are restricted to non-negative values.

### getFunction

protected LinearObjectiveFunction getFunction()

Returns:
  the optimization type.

### getConstraints

protected Collection<LinearConstraint> getConstraints()

Returns:
  the optimization type.

### optimize

public PointValuePair optimize(OptimizationData... optData) throws TooManyIterationsException
Stores data and performs the optimization.

The list of parameters is open-ended so that sub-classes can extend it with arguments specific to their concrete implementations.

When the method is called multiple times, instance data is overwritten only when actually present in the list of arguments: when not specified, data set in a previous call is retained (and thus is optional in subsequent calls).

Important note: Subclasses must override `BaseOptimizer.parseOptimizationData(OptimizationData[])` if they need to register their own options; but then, they must also call `super.parseOptimizationData(optData)` within that method.

Overrides:
  `optimize` in class `MultivariateOptimizer`
Parameters:
  `optData` - Optimization data. In addition to those documented in `MultivariateOptimizer`, this method will register the following data:
  - `LinearObjectiveFunction`
  - `LinearConstraintSet`
  - `NonNegativeConstraint`
Returns:
  a point/value pair that satisfies the convergence criteria.
Throws:
  `TooManyIterationsException` - if the maximal number of iterations is exceeded.

### parseOptimizationData

protected void parseOptimizationData(OptimizationData... optData)
Scans the list of (required and optional) optimization data that characterize the problem.

Overrides:
  `parseOptimizationData` in class `MultivariateOptimizer`
Parameters:
  `optData` - Optimization data. The following data will be looked for:
  - `LinearObjectiveFunction`
  - `LinearConstraintSet`
  - `NonNegativeConstraint`